/* 
 * File:   p-1factorizator.h
 * Copyright 2009 Filippo Bergamasco (fbergama@gmail.com)
 *
 * This file is part of infact.
 *
 * infact is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * infact is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with infact.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created on January 20, 2009, 2:36 PM
 */

#ifndef _P_1FACTORIZATOR_H
#define	_P_1FACTORIZATOR_H

#include "../factorizationalgorithm.h"

class P1Factorizator : public FactorizationAlgorithm {
public:
    P1Factorizator() : FactorizationAlgorithm( NULL ) { };
    virtual ~P1Factorizator();

    virtual FactorizationAlgorithm* newInstance( mpz_class* n );
    mpz_class* findNonTrivialFactor();
    std::string getName();

protected:
    P1Factorizator( mpz_class* n ) : FactorizationAlgorithm( n ) {};
};

#endif	/* _P_1FACTORIZATOR_H */

